//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Interop.Server.AnyTypeTest
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Set Any Type Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class SetAnyTypeValueRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.DynamicClient.AnyTypeDto _anyTypeValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public SetAnyTypeValueRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="anyTypeValue">The Any type value to be set.</param>
        public SetAnyTypeValueRequestDto(Tecan.Sila2.DynamicClient.DynamicObjectProperty anyTypeValue, Tecan.Sila2.IBinaryStore store)
        {
            AnyTypeValue = new Tecan.Sila2.DynamicClient.AnyTypeDto(anyTypeValue, store);
        }
        
        /// <summary>
        /// The Any type value to be set.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.DynamicClient.AnyTypeDto AnyTypeValue
        {
            get
            {
                return _anyTypeValue;
            }
            set
            {
                _anyTypeValue = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/AnyTypeTest/v1/Command/SetAnyTypeValue";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(AnyTypeValue, "anyTypeValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(AnyTypeValue, "anyTypeValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Set Any Type Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class SetAnyTypeValueResponseDto : Tecan.Sila2.ISilaTransferObject<SetAnyTypeValueResponse>
    {
        
        private Tecan.Sila2.StringDto _receivedAnyType;
        
        private Tecan.Sila2.DynamicClient.AnyTypeDto _receivedValue;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public SetAnyTypeValueResponseDto()
        {
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public SetAnyTypeValueResponseDto(SetAnyTypeValueResponse inner, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedAnyType = new Tecan.Sila2.StringDto(inner.ReceivedAnyType, store);
            ReceivedValue = new Tecan.Sila2.DynamicClient.AnyTypeDto(inner.ReceivedValue, store);
        }
        
        /// <summary>
        /// The type that has been received.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto ReceivedAnyType
        {
            get
            {
                return _receivedAnyType;
            }
            set
            {
                _receivedAnyType = value;
            }
        }
        
        /// <summary>
        /// The value that has been received.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.DynamicClient.AnyTypeDto ReceivedValue
        {
            get
            {
                return _receivedValue;
            }
            set
            {
                _receivedValue = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public SetAnyTypeValueResponse Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new SetAnyTypeValueResponse(ReceivedAnyType.Extract(store), ReceivedValue.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static SetAnyTypeValueResponseDto Create(SetAnyTypeValueResponse inner, Tecan.Sila2.IBinaryStore store)
        {
            return new SetAnyTypeValueResponseDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return (("" + Argument.Require(ReceivedAnyType, "receivedAnyType")) 
                        + Argument.Require(ReceivedValue, "receivedValue"));
        }
    }
}
